// <doc_history>
/**
 * @section LICENSE
 * Copyright &copy; 2012 Safran Morpho - Safran Morpho confidential - all rights reserved
 *
 * @section DESCRIPTION
 *
 *
 * @file Security_types.thrift
 *
 * CHANGELOG
 * 23 nov 2012  - Initiate header
 * 10 dec 2012  - Change namespace to comply MPH coding rules.
 * 25 jul 2013  - Added enumeration 'Passphrase_id'
 * 20 feb 2014  - Add namespace for java and C# generation
 * 04 nov 2015  - Change java namespace for coherency
 */
// </doc_history>

include "Generic_types.thrift"

namespace cpp Distant_cmd
namespace java com.morpho.distant_cmd

/**
 * Security object identifier
 */
typedef i32 Sec_obj_ID

/**
* Enumeration for Passphrase ID
*/
enum Passphrase_id
{
    SSL_profile_0 = 0,
    SSL_profile_1,
}
/**
 * Security object identifier not found in the terminal secure container
 */
exception Sec_obj_ID_not_found_error
{
    1: required Generic_types.Generic_error_code  err_code;
}
